<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfJP_DailyHotelContract ArrayType
 * @subpackage Arrays
 */
class ArrayOfJP_DailyHotelContract extends AbstractStructArrayBase
{
    /**
     * The DailyContract
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\JP_DailyHotelContract[]
     */
    public $DailyContract;
    /**
     * Constructor method for ArrayOfJP_DailyHotelContract
     * @uses ArrayOfJP_DailyHotelContract::setDailyContract()
     * @param \StructType\JP_DailyHotelContract[] $dailyContract
     */
    public function __construct(array $dailyContract = array())
    {
        $this
            ->setDailyContract($dailyContract);
    }
    /**
     * Get DailyContract value
     * @return \StructType\JP_DailyHotelContract[]|null
     */
    public function getDailyContract()
    {
        return $this->DailyContract;
    }
    /**
     * Set DailyContract value
     * @throws \InvalidArgumentException
     * @param \StructType\JP_DailyHotelContract[] $dailyContract
     * @return \ArrayType\ArrayOfJP_DailyHotelContract
     */
    public function setDailyContract(array $dailyContract = array())
    {
        foreach ($dailyContract as $arrayOfJP_DailyHotelContractDailyContractItem) {
            // validation for constraint: itemType
            if (!$arrayOfJP_DailyHotelContractDailyContractItem instanceof \StructType\JP_DailyHotelContract) {
                throw new \InvalidArgumentException(sprintf('The DailyContract property can only contain items of \StructType\JP_DailyHotelContract, "%s" given', is_object($arrayOfJP_DailyHotelContractDailyContractItem) ? get_class($arrayOfJP_DailyHotelContractDailyContractItem) : gettype($arrayOfJP_DailyHotelContractDailyContractItem)), __LINE__);
            }
        }
        $this->DailyContract = $dailyContract;
        return $this;
    }
    /**
     * Add item to DailyContract value
     * @throws \InvalidArgumentException
     * @param \StructType\JP_DailyHotelContract $item
     * @return \ArrayType\ArrayOfJP_DailyHotelContract
     */
    public function addToDailyContract(\StructType\JP_DailyHotelContract $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\JP_DailyHotelContract) {
            throw new \InvalidArgumentException(sprintf('The DailyContract property can only contain items of \StructType\JP_DailyHotelContract, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->DailyContract[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\JP_DailyHotelContract|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\JP_DailyHotelContract|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\JP_DailyHotelContract|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\JP_DailyHotelContract|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\JP_DailyHotelContract|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string DailyContract
     */
    public function getAttributeName()
    {
        return 'DailyContract';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfJP_DailyHotelContract
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
